public _cerca_massimi

.model small
.data

		N_MAX_LOCALI	dw 0
		MAX_ASSOLUTO	dw 0

.code

_cerca_massimi proc

					push bp
					mov bp, sp
					
					push bx
					push cx
					push si
					
					xor ax, ax
					xor bx, bx
					xor cx, cx
					xor si, si
					
					mov cx, [bp+6]
					mov si, [bp+4]
					dec cx ; il ciclo va fatti n-1 volte
					
ciclo:				mov ax, [si]
					mov bx, [si+2]
					call check
					add si, 4
					loop ciclo
					
					mov si, [bp+8]
					mov ax, MAX_ASSOLUTO
					mov [si], ax
					mov ax, N_MAX_LOCALI
					
					pop si
					pop cx
					pop bx
					pop bp
					
					ret

_cerca_massimi endp

check proc
					push ax
					push bx
					push cx
					push dx
					
					mov cx, [si+4]
					mov dx, [si+6]
					
					; vediamo se il primo numero e' positivo o negativo
					test bx, 080h
					jnz first_neg
					; il primo e' positivo
					test dx, 080h
					; questa jmp risulta essere troppo lunga, dividiamola in 2 salti
					jnz fine_half ; il secondo e' negativo. non siamo in un massimo locale
					
both_pos:			; confrontiamo i 16 bit piu' significativi
					cmp bx, dx
					ja max_locale
					; confrontiamo i 16 bit meno significativi
					cmp ax, cx
					ja max_locale
					jmp	fine
					
first_neg:			; vediamo se il secondo numero e' positivo o negativo
					test dx, 080h
					jnz both_neg
					; questo numero e' positivo, quindi sicuramente piu' grande del primo
					; non siamo in presenza di un massimo locale
					jmp fine
					
both_neg:			; entrambi negativi. faccio il complemento a 2 di entrambi,
					; se il valore del secondo e' piu' grande del primo,
					; siamo in un massimo locale
					not bx
					not ax
					inc ax
					adc bx, 0
					
					not dx
					not cx
					inc cx
					adc dx, 0
					
					; confrontiamo i 16 bit piu' significativi
					cmp bx, dx
					jb max_locale
					; confrontiamo i 16 bit meno significativi
					cmp ax, cx
					jb max_locale
					jmp	fine
					
max_locale:			mov cx, N_MAX_LOCALI
					inc cx
					mov N_MAX_LOCALI, cx
					jmp salta
					
fine_half:			jmp fine
					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					
					; adesso dobbiamo aggiornare il massimo assoluto
					; usiamo lo stesso metodo di prima
salta:				mov ax, [si]
					mov bx, [si+2]
					mov cx, MAX_ASSOLUTO
					mov dx, MAX_ASSOLUTO[2]
					
					; vediamo se il primo numero e' positivo o negativo
					test bx, 080h
					jnz first_neg2
					; il primo e' positivo
					test dx, 080h
					jnz fine ; il secondo e' negativo. non e' un massimo assoluto
					
both_pos2:			; confrontiamo i 16 bit piu' significativi
					cmp bx, dx
					ja new_max_assoluto
					; confrontiamo i 16 bit meno significativi
					cmp ax, cx
					ja new_max_assoluto
					jmp	fine
					
first_neg2:			; vediamo se il secondo numero e' positivo o negativo
					test dx, 080h
					jnz both_neg2
					; questo numero e' positivo, quindi sicuramente piu' grande del primo
					; non siamo in presenza di un massimo assoluto
					jmp fine
					
both_neg2:			; entrambi negativi. faccio il complemento a 2 di entrambi,
					; se il valore del secondo e' piu' grande del primo,
					; siamo in un massimo assoluto
					not bx
					not ax
					inc ax
					adc bx, 0
					
					not dx
					not cx
					inc cx
					adc dx, 0
					
					; confrontiamo i 16 bit piu' significativi
					cmp bx, dx
					jb new_max_assoluto
					; confrontiamo i 16 bit meno significativi
					cmp ax, cx
					jb new_max_assoluto
					jmp	fine
					
new_max_assoluto:	mov MAX_ASSOLUTO, ax
					mov ax, MAX_ASSOLUTO
fine:				pop dx
					pop cx
					pop bx
					pop ax
					
					ret
check endp

end
