; Si vuole programmare un sistema a processore in grado di gestire
; l'inserimento e lestrazione di valori su 8 bit in/da un buffer
; circolare. Il sistema a processore esegue le seguenti operazioni:
;   - acquisisce valori su 8 bit (interpretati come numeri senza segno)
;     che giungono attraverso la porta A dell'8255 (programmata in modo
;     1 e connessa allinterrupt 39);
;   - tali valori vengono memorizzati nel buffer circolare: se il buffer
;      pieno, il dato in arrivo viene scartato
;   - se viene ricevuto il valore 0, non si inserisce nulla, si estrae
;     un elemento dal buffer e lo si invia tramite la porta B.
#start=Emu8255.exe#

	LEN equ 5
     
.model small          
.data

	NUM db 4 dup(0)
		
.stack     
.code   

			; procedura di inizializzazione della interrupt vector table
INIT_IVT	proc
			push ax
			push bx
			push dx
			push ds
			xor	ax, ax
			mov	ds, ax      
		
			; channel 7
			mov	bx, 39		
			shl	bx, 2		
			mov ax, offset ISR_PA_IN
			mov	ds:[bx], ax
			mov	ax, seg ISR_PA_IN
			mov	ds:[bx+2], ax       
			; channel 6
			mov	bx, 38		
			shl	bx, 2		
			mov ax, offset ISR_PA_OUT
			mov	ds:[bx], ax
			mov	ax, seg ISR_PA_OUT
			mov	ds:[bx+2], ax       		
			; channel 5
			mov	bx, 37		
			shl	bx, 2		
			mov ax, offset ISR_PB_IN
			mov	ds:[bx], ax
			mov	ax, seg ISR_PB_IN
			mov	ds:[bx+2], 	AX       				
			; channel 4
			mov	bx, 36		
			shl	bx, 2		
			mov ax, offset ISR_PB_OUT
			mov	ds:[bx], ax
			mov	ax, seg ISR_PB_OUT
			mov	ds:[bx+2], ax              		
					
			pop	ds
			pop	dx
			pop	bx
			pop	ax
			ret
INIT_IVT	endp

INIT_8255	proc
		    mov al, 10110100b
		    out 083h, al
		    mov al, 00001001b
		    out 083h, al 
		    mov al, 00000101b
		    out 083h, al
            ret
INIT_8255   endp        


ISR_PA_IN       proc
                in al, 080h
                cmp si, 4
                jz stampa_numero
                cmp al, '#'
                jz stampa_numero
                ;si suppone che se il codice ascii del numero < '9'
                ;allora si tratta di un carattere ascii
                cmp al, '9'
                ja is_ascii 
                sub al, byte ptr '0'
cont:           mov NUM[si], al
                inc si
                jmp fine

is_ascii:       sub al, 87
                jmp cont
                
stampa_numero:  cmp si, 4
                jz stampa
                mov bx, 4
                sub bx, si
                ; riempio di zeri la stringa
ciclo1:         mov al, NUM[si-1]
                mov NUM[si], al
                dec si
                jnz ciclo1
                mov si, 0
ciclo2:         mov NUM[si], byte ptr 0
                inc si
                dec bx
                jnz ciclo2
stampa:         mov al, NUM[3]
                mov bl, NUM[2]
                shl bl, 4
                or al, bl
                out 081h, al
                mov al, NUM[1]
                mov bl, NUM[0]
                shl bl, 4
                or al, bl
                out 081h, al               
                mov si, 0
                sti
fine:           iret    
ISR_PA_IN       endp             
              
ISR_PA_OUT  proc
            iret
ISR_PA_OUT  endp

ISR_PB_IN proc
          iret
ISR_PB_IN endp


ISR_PB_OUT  proc               
            mov al, 0FFh
            out 082h, al    
ISR_PB_OUT  endp                                  
                                   
            
.startup
    
		cli         
		call INIT_IVT
		call INIT_8255
		sti
		mov si, 0           
              
next:  	nop         
		;hlt
		jmp next

.exit
end
