;Si vuole programmare un sistema a processore basato su 8086 nel modo seguente:
;1. Il sistema controlla in polling se sulla porta A dell'8255, programmata in modo 0, e'
;stato inviato un nuovo dato su 8 bit (ogni cambio di valore corrisponda a un nuovo
;dato) e memorizza la sequenza in un vettore opportunamente dimensionato (vedi
;punto seguente)
;2. L'acquisizione si interrompe quando sulla porta A dell'8255 e' presente un valore gia'
;   ricevuto; a seguito di questo evento
;     - Parte un'attesa di 8 secondi al termine della quale
;       la sequenza ricevuta viene inviata tramite la porta B dell'8255, programmata
;       in modo 1 output (tramite IR1).
;3. Una volta svuotato il vettore, il sistema ricomincia a ricevere dati come da punto 1.

#start=8255.exe#   
#start=8253_.exe#

.model small          
.data

	VETT db 512 dup(0)
	LAST db 0
	
.stack     
.code   

			; procedura di inizializzazione della interrupt vector table
INIT_IVT	proc
			push ax
			push bx
			push dx
			push ds
			xor	ax, ax
			mov	ds, ax      
		
			; channel 7
			mov	bx, 39		
			shl	bx, 2		
			mov ax, offset ISR_PA_IN
			mov	ds:[bx], ax
			mov	ax, seg ISR_PA_IN
			mov	ds:[bx+2], ax       
			; channel 6
			mov	bx, 38		
			shl	bx, 2		
			mov ax, offset ISR_PA_OUT
			mov	ds:[bx], ax
			mov	ax, seg ISR_PA_OUT
			mov	ds:[bx+2], ax       		
			; channel 5
			mov	bx, 37		
			shl	bx, 2		
			mov ax, offset ISR_PB_IN
			mov	ds:[bx], ax
			mov	ax, seg ISR_PB_IN
			mov	ds:[bx+2], 	AX       				
			; channel 4
			mov	bx, 36		
			shl	bx, 2		
			mov ax, offset ISR_PB_OUT
			mov	ds:[bx], ax
			mov	ax, seg ISR_PB_OUT
			mov	ds:[bx+2], ax
			; channel 3
    		mov bx, 35
    		shl bx, 2
    		mov ax, offset ISR_COUNTER0
    		mov ds:[bx], ax
    		mov ax, seg ISR_COUNTER0
    		mov ds:[bx+2], ax
    		; channel 2
    		mov bx, 34
    		shl bx, 2
    		mov ax, offset ISR_COUNTER12
    		mov ds:[bx], ax
    		mov ax, seg ISR_COUNTER12
    		mov ds:[bx+2], ax            		
					
			pop	ds
			pop	dx
			pop	bx
			pop	ax
			ret
INIT_IVT	endp

INIT_8255	proc
		    mov al, 10010100b
		    out 083h, al
		    mov al, 00000101b
		    out 083h, al
            ret
INIT_8255   endp

INIT_8253 proc
          mov al, 01110100b
          out 063h, al
          mov al, 10-1
          out 061h, al
          
          mov al, 10000000b
          out 063h, al
          mov ax, 10-1
          out 062h, al
          xchg al, ah
          out 062h, al
          ret
INIT_8253 endp

ISR_COUNTER0 proc
             ret
ISR_COUNTER0 endp  

ISR_COUNTER12 proc
              
              dec bx
ciclo3:       cmp bx, 0
              js fine
              mov al, VETT[bx]
              out 081h, al
              dec bx
              jmp ciclo3
fine:         stc
              ret
ISR_COUNTER12 endp

; ISR for reading the value received on PA            
ISR_PA_IN   proc
            ; aquisizione valori da portA 8255              
            in al, 080h
            iret    
ISR_PA_IN   endp             
              
; ISR for waiting a confirmation that the value written on PA is externally read 
ISR_PA_OUT  proc               
            iret    
ISR_PA_OUT  endp                                  
                           
; ISR for reading the value received on PB                                       
ISR_PB_IN   proc
            iret    
ISR_PB_IN   endp             
                                          
; ISR for waiting a confirmation that the value written on PB is externally read                                           
ISR_PB_OUT  proc
            iret    
ISR_PB_OUT  endp         
            
.startup
    
		cli         
		call INIT_IVT
		call INIT_8255
		sti            
        
        mov cx, 0
        mov bx, 0
        
ciclo:  in al, 080h
        cmp al, LAST
        jz ciclo
        mov LAST, al
        mov si, 0
        
ciclo2: cmp si, bx
        jz next
        cmp VETT[si], al
        jz trovato
        inc si
        jmp ciclo2

next:   mov VETT[bx], al
        inc bx
        jmp ciclo
        
trovato: call INIT_8253

wait_:  jnc wait_
        xor bx, bx
        jmp ciclo 

.exit
end
