; La specifica di funzionamento del sistema  la seguente.
;    1. Il sistema legge un numero con segno (espressi in complemento a 2) dalla porta A dell8255
;       non appena questo  disponibile (la segnalazione avviene sullIR4 dell8259)
;    2. Scrive il dato letto in una matrice 5x5, riempiendola per righe. Una volta completata la
;       scrittura della matrice (cella 5,5) il successivo dato viene scritto nella prima posizione
;      (cella 0,0) come mostrato nellesempio
;    3. Ogni 10 ms, a seguito di una richiesta di interruzione su IR1 dell8259 da parte dell8253,
;       calcola la differenza tra il valore massimo e quello minimo memorizzati sulla diagonale della
;       matrice, come mostrato nellesempio, e lo invia sulla porta B dell8255.

#start=8255.exe#
#start=8253.exe#

    LEN equ 5
    
    .model small          
    .data
               MATR db 25 dup (0)
			   N db 0
    .stack     
    .code   
    
    
    ; procedura di inizializzazione della interrupt vector table
INIT_IVT	PROC
		PUSH 	AX
		PUSH	BX
		PUSH	DX
		PUSH 	DS
		XOR	AX, 	AX
		MOV	DS, 	AX      
		
		; channel 7
		MOV	BX, 	39		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_PA_IN
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_PA_IN
		MOV	DS:[BX+2], 	AX       
        ; channel 3
		MOV	BX, 	35		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_COUNT0
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_COUNT0
		MOV	DS:[BX+2], 	AX  		
					
		POP	DS
		POP	DX
		POP	BX
		POP	AX
		RET
INIT_IVT	ENDP

INIT_8255	PROC
		    mov al, 10110000b
			out 083h, al ;out 033h, al
			mov al, 00001001b
		    out 083h, al ;out 033h, al
            RET
INIT_8255   ENDP

INIT_8253	PROC
            mov al, 00110100b
			out 063h, al ;out 023h, al
			mov ax, 50-1 ;mov ax, 2000-1
			out 060h, al ;out 020h, al
			xchg al, ah
			out 060h, al ;out 020h, al
            RET
INIT_8253   ENDP

ISR_PA_IN  PROC
		   push ax
		   push bx
           in al, 080h ;in al, 030h
		   mov bl, N
		   mov bh, 0
		   mov MATR[bx], al
		   inc bx
		   cmp bx, 25
		   jnz cont
		   mov bx, 0
cont:	   mov N, bl
		   pop bx
		   pop ax
		   IRET
ISR_PA_IN  ENDP

ISR_COUNT0  PROC
			mov ah, MATR[0] ; max temporaneo
			mov al, MATR[6] ; min temporaneo
			cmp ah, al
			jl swap_al_ah
            ; in ah ho l'attuale massimo
            ; in al ho l'attuale minimo
            mov cl, 3
            mov si, 10
cont1:      mov bl, MATR[si]
            cmp al, bl ; vedo se trovo il nuovo minimo
            jg swap_al_bl
cont2:      cmp ah, bl
            jl swap_ah_bl
cont3:      add si, 6
            dec cl
            jnz cont1
            sub ah, al
            xchg al, ah
            out 081h, al ;out 061h, al
            jmp fine                 

swap_al_ah: xchg al, ah
            jmp cont1
swap_al_bl: xchg al, bl
            jmp cont2
swap_ah_bl: xchg ah, bl
            jmp cont3            
fine:       IRET    
ISR_COUNT0  ENDP 
            
    
       .startup    
       CLI         
       call INIT_IVT
       call INIT_8255
       call INIT_8253
       STI            
              
next:  nop         
       ;hlt

       jmp next
          
    
    
    .exit

    end
;pb