                          
                                            
    .model small          
    .data     
matr    db  25 dup (0)       
    .stack     
    .code   
    
    
    ; procedura di inizializzazione della interrupt vector table
INIT_IVT	PROC
		PUSH 	AX
		PUSH	BX
		PUSH	DX
		PUSH 	DS
		XOR	AX, 	AX
		MOV	DS, 	AX      
		
		; channel 7
		MOV	BX, 	39		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_PA_IN
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_PA_IN
		MOV	DS:[BX+2], 	AX       			
		; channel 3
		MOV	BX, 	35		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_COUNT0
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_COUNT0
		MOV	DS:[BX+2], 	AX 							
										
		POP	DS
		POP	DX
		POP	BX
		POP	AX 		
		RET
INIT_IVT	ENDP

; ISR for reading the value received on PA            
ISR_PA_IN   PROC
            STI       
            push    ax         
            in      al, 080h
            mov     matr[si],al  
            inc     si
            cmp     si, 25
            jne     valid
            mov     si, 0
    valid:  pop     ax           
            out     081h, al           
	        MOV	    AL, 00100000b
	        OUT	    DX, AL
            CLI
            IRET    
ISR_PA_IN   ENDP             
                             
ISR_COUNT0  PROC    
            push    ax
            push    di          
            push    cx
            mov     cx, 4
            mov     di, 0
            mov     al, matr[di]
            mov     ah, matr[di]
    next:   add     di,6
            cmp     al, matr[di]
            jl      no_max
            mov     al, matr[di]
            jmp     no_min
    no_max: cmp     ah, matr[di]
            jg      no_min
            mov     ah, matr[di]           
    no_min: loop    next           
            sub     al, ah
            out     081h, al           
	        MOV	    AL, 00100000b
	        OUT	    DX, AL
            pop     cx
            pop     di
            pop     ax                         
            IRET    
ISR_COUNT0  ENDP   
                                  
INIT_8255   PROC
            ; init 8255    
            mov al, 10110000b ; GA(m=1,pa=in,pcu=hndsk/intrpt) ; GB(m=0,pb=out,pcl=out)
            out 083h, al
            ; set PC4 to enable interrupt on PA in
            mov al, 00001001b    
            out 083h, al               
            RET            
INIT_8255   ENDP          

INIT_8253   PROC
            ;init 8253
            ;counter0 init
            mov al, 00110100b
            out 063h, al 
            mov ax, 2000-1
            xchg al, ah 
            out 060h, al
            xchg al, ah                     
            out 060h, al                     
            RET
INIT_8253   ENDP    
          

            .startup    
            CLI         
            call INIT_IVT	    
            call INIT_8255 
            call INIT_8253
            STI        
            
            mov  si, 0                  
block:      ;hlt
            jmp  block
                      
            .exit

            end  ; set entry point and stop the assembler.
