; Si scriva un programma che esegua le seguenti operazioni:
;  a. Definisca un vettore VETT di 3 elementi ciascuno su 32 bit,
;     inizializzato a piacimento a numeri positivi e negativi senza
;     utilizzare la direttiva DUP.
;  b. Esegua la somma di tutti i numeri positivi contenuti in VETT e
;     depositi il risultato in una variabile VARP su 32 bit.
;  c. Esegua la somma di tutti i numeri negativi contenuti in VETT e 
;     depositi il risultato in una variabile VARN su 32 bit.
;
;  Si definiscano i valori di VETT piu' volte, cercando di osservare
;  (tramite i flag) le possibili situazioni di carry e overflow

	LEN    equ 8
	OVF_P  equ 0001H
	OVF_N  equ 0002H

.model small
.data

	; non da overflow
	;VETT dd 2, 4, -3, 6, 5, 800000FFh, 0FFFFFFFFh, -7
	
	; overflow sui numeri negativi
	;VETT dd 2, 4, -3, 6, 5, 80000000h, 0FFFFFFFFh, -7
	
	; overflow sui numeri positivi
	;VETT dd 2, 4, -3, 6, 7FFFFFFFh, 800000FFh, 0FFFFFFFFh, -7
	
	; overflow sui numeri positivi e negativi
	VETT dd 2, 4, -3, 6, 7FFFFFFFh, 80000000h, 0FFFFFFFFh, -7
	
	VARP dd 0
	VARN dd 0

.stack
.code
.startup
	
	       mov  cx, LEN
	       lea  si, VETT
		   mov  dx, 0                ; lo uso come flag per vedere gli overflow
ciclo:     mov  bx, word ptr [si]
	       mov  ax, word ptr [si]+2
	       test ax, 08000h
	       jnz  is_neg
	    
		   ;il numero e' positivo
	       ;se ci sono ovf positivi non faccio la somma
		   test dl, OVF_P
		   jnz next
	       add word ptr VARP,   bx
	       adc word ptr VARP+2, ax
		   jno next
		   or  dx, OVF_P
	       jmp next
		
		   ;il numero e' negativo
	       ;se ci sono ovf negativi non faccio la somma
is_neg:	   test dl, OVF_N
		   jnz next
           add word ptr VARN,   bx
	       adc word ptr VARN+2, ax
		   jno next
		   or  dx, OVF_N
	   
next:      add si, 4
	       dec cx
		   jnz  ciclo
	    
		   ;se ci sono ovf positivi, metto a 0 VARP
		   test dx, OVF_P
		   jz   no_ovf_p
		   mov  word ptr VARP, 0
		   mov  word ptr VARP+2, 0
		
          ;se ci sono ovf negativi, metto a 0 VARN
no_ovf_p: test dx, OVF_N
          jz fine
		  mov  word ptr VARN, 0
		  mov  word ptr VARN+2, 0
fine:     nop
          .exit
	      end
		  