;Si scriva un programma che esegua le seguenti operazioni:
;	a. Definisca in memoria una matrice quadrata MATR di N elementi
;	   positivi ciascuno su 8 bit
;	b. Ne trasformi il contenuto moltiplicando e dividendo (nell'ordine)
;	   il valore di ogni cella per il proprio vicino destro e sinistro,
;	   rispettivamente:
;	      i.  Se l'elemento  su un lato, considerare il valore mancante
;		      uguale a 1
;		  ii. Se un elemento puo' provocare una operazione di divisione per 0,
;		      sostituirlo col valore 1
;n.b. Si supponga che non si ecceda mai la precisione massima raggiungibile
;	 con il tipo byte

				N		equ 4
				CONF_S	equ 01h
				CONF_D	equ 02h

.model small
.stack
.data

				MATR 	db 1, 2, 4, 5
						db 2, 3, 5, 7
						db 3, 4, 6, 8
						db 0, 3, 5, 1
						
				TEMP	db N*N dup (0)

.code
.startup
				lea dx, MATR
				mov bx, 0
				mov si, 0
				mov cx, N*N
		
ciclo1:			jmp check_confine
continue:		test ax, CONF_S
				jnz confine_sx
				test ax, CONF_D
				jnz confine_dx
				
				;non sono a confine
				
no_confine:		mov al, MATR[bx][si]
				mul MATR[bx][si+1]
				; verifico che l'elemento a sinistra non sia zero
				test byte ptr MATR[bx][si-1], 0FFh
				jz store_al ; e' 0, divido al per 1, memorizzo quindi al
				div MATR[bx][si-1]
				mov byte ptr TEMP[bx][si], al 

next:			inc si
				cmp si, N
				jz new_row
				dec cx
				jnz ciclo1
				jmp store_matrix

new_row:		mov si, 0
				add bx, N
				dec cx
				jnz ciclo1
				jmp store_matrix

store_al:		mov byte ptr TEMP[bx][si], al
				jmp next

confine_sx:		mov al, MATR[bx][si]
				mul MATR[bx][si+1]
				; sono a confine sinistro, dovrei dividere per 1, non lo faccio
				mov byte ptr TEMP[bx][si], al
				jmp next
				
confine_dx:		; sono a confine destro, dovrei moltiplicare per 1, non lo faccio
				; verifico che l'elemento di sinistra non sia zero
				mov al, MATR[bx][si-1]
				test al, 0FFh
				jz next ; l'elemento e' 0, moltiplico e divido per uno, l'elemento non varia
				mov al, MATR[bx][si]
				div MATR[bx][si-1]
				mov byte ptr TEMP[bx][si], al
				jmp next
				
check_confine:	mov ax, si
				test ax, 0FFFFh
				jz set_conf_s
				cmp ax, N-1
				jz set_conf_d
				jmp no_confine

set_conf_s:		mov ax, CONF_S
				jmp continue
set_conf_d:		mov ax, CONF_D
				jmp continue

store_matrix:	mov cx, N*N
				mov si, 0
ciclo2:			mov al, byte ptr TEMP[si]
				mov byte ptr MATR[si], al
				inc si
				dec cx
				jnz ciclo2
fine:			nop
				.exit
				end
