; Si scriva un programma per il sistema che
; a. legga ogni 10 millisecondi i dati scritti sulla porta B dell8255,
;    e ogni 5 minuti i dati scritti sulla porta A,
; b. invii alla porta C lultimo dato ricevuto ogni 50 millisecondi.
    .model small          
    .data
        
        VAL db 0
                
    .stack     
    .code   
    
    
    ; procedura di inizializzazione della interrupt vector table
INIT_IVT	PROC
		PUSH 	AX
		PUSH	BX
		PUSH	DX
		PUSH 	DS
		XOR	AX, 	AX
		MOV	DS, 	AX      
		
		; channel 7
		MOV	BX, 	39		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_PA_IN
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_PA_IN
		MOV	DS:[BX+2], 	AX       
		; channel 6
		MOV	BX, 	38		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_PA_OUT
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_PA_OUT
		MOV	DS:[BX+2], 	AX       		
		; channel 5
		MOV	BX, 	37		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_PB_IN
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_PB_IN
		MOV	DS:[BX+2], 	AX       				
		; channel 4
		MOV	BX, 	36		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_PB_OUT
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_PB_OUT
		MOV	DS:[BX+2], 	AX
		; channel 3
		mov bx, 35
		shl bx, 2
		mov ax, offset ISR_COUNTER0
		mov ds:[bx], ax
		mov ax, seg ISR_COUNTER0
		mov ds:[bx+2], ax
		; channel 2
		mov bx, 34
		shl bx, 2
		mov ax, offset ISR_COUNTER12
		mov ds:[bx], ax
		mov ax, seg ISR_COUNTER12
		mov ds:[bx+2], ax       		
					
		POP	DS
		POP	DX
		POP	BX
		POP	AX
		RET
INIT_IVT	ENDP

INIT_8255	PROC
		mov al, 10010010b
		out 083h, al
        RET
INIT_8255   ENDP

INIT_8253 proc
          mov al, 00110100b
          out 063h, al
          mov ax, 30000-1
          out 060h, al
          xchg al, ah
          out 060h, al
          
          mov al, 01110100b
          out 063h, al
          mov ax, 30000-1
          out 061h, al
          xchg al, ah
          out 061h, al
          
          mov al, 10110100b
          out 063h, al
          mov ax, 30000-1
          out 062h, al
          xchg al, ah
          out 062h, al 
          ret
INIT_8253 endp

; ISR for reading the value received on PA            
ISR_PA_IN   PROC                
            IRET    
ISR_PA_IN   ENDP             
              
; ISR for waiting a confirmation that the value written on PA is externally read 
ISR_PA_OUT  PROC               
            IRET    
ISR_PA_OUT  ENDP                                  
                           
; ISR for reading the value received on PB                                       
ISR_PB_IN   PROC              
            IRET    
ISR_PB_IN   ENDP             
                                          
; ISR for waiting a confirmation that the value written on PB is externally read                                           
ISR_PB_OUT  PROC
            IRET    
ISR_PB_OUT  ENDP 

ISR_COUNTER0 proc
             
             in al, 081h
             mov VAL, al
             inc cx
             cmp cx, 5
             jz print
             jmp fine
             
print:       mov al, VAL
             out 082h, al
             mov cx, 0
             
fine:        iret
ISR_COUNTER0  endp
                

ISR_COUNTER12 proc
              
              in al, 080h
              mov VAL, al
              inc cx
              cmp cx, 5
              jz print2
              jmp fine
             
print2:       mov al, VAL
              out 082h, al
              mov cx, 0
              iret
ISR_COUNTER12 endp
            
    
.startup    
       mov cx, 0
	   CLI         
       call INIT_IVT
       call INIT_8255
       call INIT_8253
       STI            
        
next:  nop         
       ;hlt

       jmp next
          
.exit
end
