; Si consideri un sistema a processore avente l'architettura mostrata in figura.
; Il sistema acquisisce ogni 250 ms un byte dalla porta A dell'8255 (programmata in modo 0).
; I byte provenienti dall'8255 corrispondono a pacchetti di 255 interi su 16 bit con segno:
; ogni intero viene inviato spedendo prima il MSB e poi il LSB. Al termine della ricezione di
; ciascun pacchetto (255*2 ricezioni) viene ricevuta una coppia di byte che contiene il codice
; di parita' dei 255 interi nel pacchetto.
; Se il sistema non rileva errori, invia sulla porta B dell'8255 (anch'essa programmata in modo 0)
; i 4 byte corrispondenti alla somma degli interi nel pacchetto (partendo dal byte piu' significativo)
; ogni 15 ms. Altrimenti invia 4 byte con il valore 0FFFFFFFFh.
; 
; Esempio di calcolo della parita' (su 2 word ricevute):
;                MSB      LSB
; pacchetto 1    11010101-01000010
; pacchetto 1    10111100-11101101
; parita'        01101001-10101111

#start=8255.exe#
#start=8253.exe#

    TOTN equ 255
    
    .model small          
    .data
            N           db 0
            SUM         dd 0
            PARITY      dw 0
            PARITY_OK   db 0
            FINAL_COUNT db 0
    .stack     
    .code   
    
    
    ; procedura di inizializzazione della interrupt vector table
INIT_IVT	PROC
		PUSH 	AX
		PUSH	BX
		PUSH	DX
		PUSH 	DS
		XOR	AX, 	AX
		MOV	DS, 	AX      
		
		; channel 7
		MOV	BX, 	39		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_PA_IN
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_PA_IN
		MOV	DS:[BX+2], 	AX       
		; channel 6
		MOV	BX, 	38		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_PA_OUT
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_PA_OUT
		MOV	DS:[BX+2], 	AX       		
		; channel 5
		MOV	BX, 	37		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_PB_IN
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_PB_IN
		MOV	DS:[BX+2], 	AX       				
		; channel 4
		MOV	BX, 	36		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_PB_OUT
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_PB_OUT
		MOV	DS:[BX+2], 	AX
		; channel 3
		MOV	BX, 	35		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_COUNT0
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_COUNT0
		MOV	DS:[BX+2], 	AX      
        ; channel 2
		MOV	BX, 	34		
		SHL	BX, 	2		
		MOV AX, 	offset ISR_COUNT12
		MOV	DS:[BX], 	AX
		MOV	AX,     seg ISR_COUNT12
		MOV	DS:[BX+2], 	AX  		
					
		POP	DS
		POP	DX
		POP	BX
		POP	AX
		RET
INIT_IVT	ENDP

INIT_8255	PROC
            mov al, 10010000b
            out 083h, al
            RET
INIT_8255   ENDP

INIT_8253	 PROC 
             ; 15 ms corrispondono a 45.000 colpi di clock
             mov al, 00110100b
             out 063h, al
             mov ax, 30-1;mov ax, 45000-1
             out 060h, al
             xchg al, ah
             out 060h, al
             
			 ; 250 ms corrispondono a 750.000 colpi di clock
             ; 750.000 = 15.000(counter1) * 50 (counter2)
             mov al, 01110100b
             out 063h, al
             mov ax, 10-1;mov ax, 15000-1
             out 061h, al
             xchg al, ah
             out 061h, al
             
             mov al, 10010100b
             out 063h, al
             mov al, 5-1;mov al, 50
             out 062h, al
             
             RET
INIT_8253    ENDP

; ISR for reading the value received on PA            
ISR_PA_IN   PROC                
            in al, 080h       ;aquisizione valori da portA 8255  
                        
            IRET    
ISR_PA_IN   ENDP             
              
; ISR for waiting a confirmation that the value written on PA is externally read 
ISR_PA_OUT  PROC               

            IRET    
ISR_PA_OUT  ENDP                                  
                           
; ISR for reading the value received on PB                                       
ISR_PB_IN   PROC              
            in      al, 081h                                    
            IRET    
ISR_PB_IN   ENDP             
                                          
; ISR for waiting a confirmation that the value written on PB is externally read                                           
ISR_PB_OUT  PROC
            IRET    
ISR_PB_OUT  ENDP

ISR_COUNT0  PROC
            cmp FINAL_COUNT, byte ptr 0
            jz fine1
            cmp PARITY_OK, byte ptr 1
            jz print_sum
            mov al, 0FFh
			out 081h, al
			out 081h, al 
			out 081h, al
			out 081h, al
			jmp fine1
			  
print_sum:  mov ax, word ptr SUM
            out 081h, al
            xchg al, ah
            out 081h, al
            mov ax, byte ptr SUM+2
            out 081h, al
            xchg al, ah
            out 081h, al
            
fine1:      IRET
ISR_COUNT0  ENDP

ISR_COUNT12   PROC
              in al, 080h
			  xchg al, ah
			  in al, 080h
			  
			  cmp FINAL_COUNT, byte ptr 1
			  jz fine
			  ; calcolo la parita' se non e' la prima word
			  cmp N, byte ptr 0
			  jz is_first
			  cmp N, byte ptr 20 ;cmp N, byte ptr 255
			  jz check_parity
			  ;un altro numero ricevuto
			  mov bl, N
			  inc bl
			  mov N, bl
			  ;aggiorno la parita'			 
			  xor byte ptr PARITY[0], al
			  xor byte ptr PARITY[1], ah
			  ;aggiorniamo la somma
			  ;se ax > 0 sommiamo semplicemente
			  test ax, 08000h
			  jz is_positive
			  ;se x < 0 sottraiamo il corrispondete positivo in complemento a 2
			  neg ax
			  sub word ptr SUM, ax
			  jmp fine
			 
is_positive:  add word ptr SUM, ax
              adc word ptr SUM+2, 0
              jmp fine 
			 
is_first:     mov PARITY, ax
              mov word ptr SUM, ax
			  mov N, byte ptr 1
			  jmp fine  

check_parity: mov FINAL_COUNT, byte ptr 1
              xor ax, PARITY
			  cmp ax, 0
			  jz parity_succ
			  jmp fine
			  
parity_succ:  mov PARITY_OK, byte ptr 1
			  
fine:         IRET    
ISR_COUNT12   ENDP
            
       .startup    
       CLI         
       call INIT_IVT
       call INIT_8255
       call INIT_8253
       STI            
              
next:  nop         
      ;hlt

      jmp next
          
    
    
    .exit

    end
;pb