; Si scriva un programma in linguaggio ASM dellARM, lo si compili e se ne esegua il debug.
; Il programma deve:
;  - considerare una sequenza di 8 valori costanti, memorizzati nel literal pool
;  - analizzare tale sequenza, stabilendo se si tratta di una sequenza crescente o
;    decrescente, o non monotona.
;       1. In caso sia crescente, calcolare la media matematica degli 8 valori
;       2. In caso sia decrescente, determinare valore massimo
;       3. Se non monotona, allora indichi il valore massimo e minimo assoluto.

        		AREA    RESET, CODE, READONLY
        		ENTRY

				ldr     PC, Reset_Addr        

Reset_Addr      DCD     Reset_Handler


; Literal pool definition              
Pool DCD 8, 2, 6, 5, 6, 10, 1, 3

; Reset Handler          
Reset_Handler   				
				ldr r0, =Pool ; adr r0, Pool
				mov r11, #6   ; contatore
							 
				; vediamo la monotonia iniziale
				ldrb r1, [r0],#4
				ldrb r2, [r0],#4
				cmp r1, r2
				movle r12, #0
				movge r12, #1

				; vediamo se e' mantenuta
loop			mov r1, r2
				ldr r2, [r0],#4
				cmp r1, r2
				ble check_up
				bge check_down
cont			subs r11, #1
				beq si_monotonia
				b loop			

check_up		cmp r12, #0
				bne no_monotonia
				b cont
check_down		cmp r12, #1
				bne no_monotonia
				b cont
check_same		cmp r12, #2
				bne no_monotonia
				b cont
				
no_monotonia	; determiniamo il minimo e il massimo assoluto
				; r11 conterra' il minimo
				; r12 conterra' il massimo
				ldr r0, =Pool
				mov r10, #6	  ; contatore
				; vediamo il minimo e il massimo temporanei
				ldr r1, [r0],#4
				ldr r2, [r0],#4
				cmp r1, r2
				movle r11, r1
				movle r12, r2
				movge r11, r2
				movge r12, r1

loop2			ldr r1, [r0],#4
				; vediamo se e' il nuovo minimo
				cmp r1, r11
				movle r11, r1
				cmp r1, r12
				movge r12, r1
				subs r10, #1
				bne loop2
				b fine				
					
si_monotonia	; la sequenza e' monotona.
				; mi basta un solo confronto per sapere se e' crescente o decrescente
				ldr r0, =Pool
				cmp r1, r2
				ble is_cresc
				; monotonia decrecente, il valore massimo e' il primo
				; nel caso sia tutti gli stessi, metto il primo valore comunque
				ldr r12, [r0]
				b fine

is_cresc		mov r11, #7
				ldr r1, [r0],#4
loop3			ldr r2, [r0],#4
 				add r1, r1, r2
				subs r11, #1
				bne loop3
				mov r12, r1, lsr #3
				b fine
				
fine			nop

				END