/*
 * StQ 28.03.2011
 *
 * Sender e Receiver with Thread
 *
 * Step:
 * 1 - aggiungere questo file in
 *     /home/pso/os161/os161-base-1.99.05/kern/test
 * 2 - modificare il file
 *     /home/pso/os161/os161-base-1.99.05/kern/startup/menu.c
 *     in due punti
 * 3 - inserire il prototipo della funzione esterna
 *     int threadtest4(int, char **);
 *     nel file
 *     /home/pso/os161/os161-base-1.99.05/kern/include/test.h
 * 4 - modificare il file conf.kern aggingendo questo file
 *     all'elenco
 * 5 - effettuare
 *     config ASST0, bmake depend, bmake, bmake install
 */

#include <types.h>
#include <lib.h>
#include <thread.h>
#include <synch.h>
#include <test.h>

static struct semaphore *tsemM;
static struct semaphore *tsemS;
static struct semaphore *tsemR;
char line[132]; 
int sent_msg; 

static void sender (void *junk, unsigned long num);
static void receiver (void *junk, unsigned long num);

static void
init_sem (
  void
  )
{
  if (tsemM==NULL) {
    tsemM = sem_create("tsemM", 0);
    if (tsemM == NULL) {
      panic("threadtest: sem_create failed\n");
    }
  }
  if (tsemS==NULL) {
    tsemS = sem_create("tsemS", 0);
    if (tsemS == NULL) {
      panic("threadtest: sem_create failed\n");
    }
  }
  if (tsemR==NULL) {
    tsemR = sem_create("tsemR", 0);
    if (tsemR == NULL) {
      panic("threadtest: sem_create failed\n");
    }
  }
}

int
threadtest4 (
  int nargs,
  char **args
  )
{
  char nameS[50], nameR[50];
  int result;

  (void)nargs;
  (void)args;

  kprintf("\n\t\t\tStQ Test on Threads (sender & receiver)\n\n");

  tsemM = NULL;
  tsemS = NULL;
  tsemR = NULL;

  init_sem();

  snprintf(nameR, sizeof(nameR), "StQReceiver");
  result = thread_fork(nameR, receiver, nameR, 0, NULL);

  snprintf(nameS, sizeof(nameS), "StQSender");
  result = thread_fork(nameS, sender, nameS, 1, NULL);

  P(tsemM);
  P(tsemM);

  sem_destroy (tsemM);
  sem_destroy (tsemS);
  sem_destroy (tsemR);

  kprintf("Sent Messsages %d\n", sent_msg);
  kprintf("\n\t\t\tStQ Test on Threads ... END\n\n");

  return 0;
}

static void
sender (
  void *junk,
  unsigned long num
  )
{
  (void) num;
  (void) junk;

  while (1) {
    kprintf ("%s: ", (char *) junk);
    kgets (line, sizeof (line));
    V (tsemR);
    if (strcmp(line, "end") == 0) {
      break;
    }
    sent_msg++;         
    P (tsemS);
    kprintf ("%s: %s\n", (char *) junk, line);
  }

  V(tsemM);

  return; 
}

static void
receiver(
  void *junk,
  unsigned long num
  )
{
  unsigned int i;

  (void) num;

  while(1){
    P (tsemR);
    if (strcmp(line, "end") == 0) {
      break;
    }
    kprintf ("%s: %s ", (char *) junk, line);
    for (i=0; i<strlen(line); i++) {
      if (line[i]>='a' && line[i]<='z') {
        line[i]= (char) ((int) (line[i] + ('A' - 'a')));
      }
    }
    kprintf ("-> %s\n", line);
    V(tsemS);
  }

  V(tsemM);

  return; 
}

