/*
 * StQ 28.03.2011
 *
 * Ordering Array with Thread
 *
 * Step:
 * 1 - aggiungere questo file in
 *     /home/pso/os161/os161-base-1.99.05/kern/test
 * 2 - modificare il file
 *     /home/pso/os161/os161-base-1.99.05/kern/startup/menu.c
 *     in due punti
 * 3 - inserire il prototipo della funzione esterna
 *     int threadtest5(int, char **);
 *     nel file
 *     /home/pso/os161/os161-base-1.99.05/kern/include/test.h
 * 4 - modificare il file conf.kern aggingendo questo file
 *     all'elenco
 * 5 - effettuare
 *     config ASST0, bmake depend, bmake, bmake install
 *
 */

#include <types.h>
#include <lib.h>
#include <thread.h>
#include <synch.h>
#include <test.h>

typedef enum Boolean {
  False,
  True
} boolean;

static struct semaphore *semPrint;
static struct semaphore *semMain;
static struct semaphore **semThread;
static struct semaphore *semCount;
static struct semaphore *barrier1;
static struct semaphore *barrier2;

int num_threads, vet_size, *vet;
boolean sorted, all_ok;
int count;

static void sorter (void *junk, unsigned long num);
static int max_random (int max);

static void
sorter (
  void *junk,
  unsigned long num
  )
{
  int i, j, tmp;

  (void)junk;
  i = (int) num;

  while (sorted==False) {
    P (semThread[i]);
    P (semThread[i+1]);

    if (vet[i] > vet[i + 1]) {
      tmp = vet[i];
      vet[i] = vet[i + 1];
      vet[i + 1] = tmp;
      all_ok = False;
    }

    P (semPrint);
    kprintf ("Thread %d: vet %d %d; all_ok %d\n",
      i, vet[i], vet[i+1], all_ok);
    V (semPrint);

    V (semThread[i+1]);
    V (semThread[i]);

    P (semCount);
    count++;
    if (count == num_threads) {
      for (j=0; j<num_threads; j++)
        V (barrier1);
    }
    V (semCount);

    P (barrier1);

    P (semCount);
    count--;
    if (count == 0) {
      P (semPrint);
      kprintf ("all_ok %d\n", all_ok);
      for (j=0; j<vet_size; j++)
        kprintf ("%d ", vet[j]);
      kprintf ("\n");
      V (semPrint);
      if (all_ok == True)
        sorted = True;
      all_ok = True;
      for (j=0; j<num_threads; j++)
        V (barrier2);
    }
    V (semCount);

    P (barrier2);
  }

  V (semMain);

  return;
}

int
threadtest5 (
  int nargs,
  char **args
  )
{
  char name[50], line[50];
  int result, i;

  (void)nargs;
  (void)args;

  kprintf("\n\t\tStQ Ordering an Array with Threads\n\n");

  //semPrint = semMain = semThread = semCount = barrier1 = barrier2 = NULL;
  sorted = False;
  all_ok = True;
  count = 0;

  kprintf ("Array size: ");
  kgets (line, sizeof (line));
  vet_size = atoi (line);
  num_threads = vet_size - 1;
  vet = (int *) kmalloc (vet_size * sizeof (int));

  semMain = sem_create ("semMain", 0);
  semThread = (struct semaphore **)
    kmalloc (vet_size * sizeof (struct semaphore *));
  for (i=0; i<vet_size; i++) {
    snprintf (name, sizeof(name), "semThread%d", i);
    semThread[i] = sem_create (name, 1);
  }
  semCount = sem_create ("semCount", 1);
  barrier1 = sem_create ("barrier1", 0);
  barrier2 = sem_create ("barrier2", 0);
  semPrint = sem_create ("semPrint", 1);

  //srand (tb.millitm);
  for (i = 0; i < vet_size; i++) {
    vet[i] = max_random (1000);
    kprintf ("%d ", vet[i]);
  }
  kprintf ("\n");

  /* Create the threads */
  for (i=0; i<num_threads; i++) {
    snprintf(name, sizeof(name), "%d", i);
    result = thread_fork(name, sorter, name, i, NULL);
  }


  /* Wait for Threads */
  for (i=0; i<num_threads; i++) {
    P (semMain);
  }

  return (0);
}

static int
max_random (
  int max
  )
{
  return (int) (random () % max);
}
