/*Si realizzi, in linguaggio C, in ambiente Unix/Linux, un programma in grado di visitare un
albero di direttori visualizzandone (a video) il contenuto (in termini di sottodirettori e file).*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>

#define MAX_LEN 1024

void RecursiveRead(const char *, int);

int main(int argc, char ** argv)
{
    char buffer[MAX_LEN];
    if(argc != 2){
	printf("Usage: %s <root_dir>\n", argv[0]);
	exit(EXIT_FAILURE);
    }
    if(opendir(argv[1]) == NULL){
	sprintf(buffer, "Error on opening '%s'", argv[1]);
	perror(buffer);
	exit(EXIT_FAILURE);
    }
    printf("+ %s\n", argv[1]);
    RecursiveRead(argv[1], 2);
    return EXIT_SUCCESS;
}

void RecursiveRead(const char * path, int leading_spaces)
{
    DIR * dir;
    struct dirent * dir_struct;
    char buffer[MAX_LEN];
    int i;
    
    dir = opendir(path);
    if(dir == NULL)
    {
	sprintf(buffer, "Error on opening '%s'", path);
	perror(buffer);
	exit(EXIT_FAILURE);
    }
    
    while((dir_struct = readdir(dir)) != NULL)
    {
	if(dir_struct->d_type == DT_DIR && !(!strcmp(dir_struct->d_name, ".") || !strcmp(dir_struct->d_name, "..")))
	{
	    for(i = 0; i < leading_spaces; i++)
		printf(" ");
	    printf("+ %s\n", dir_struct->d_name);
	    sprintf(buffer, "%s/%s", path, dir_struct->d_name);
	    RecursiveRead(buffer, leading_spaces+2);
	}
	else if(dir_struct->d_type == DT_REG)
	{
	    for(i = 0; i < leading_spaces; i++)
		printf(" ");
	    printf("-> %s\n", dir_struct->d_name);
	}
    }
}