/*
 * StQ 07.04.2011
 * Compare Dir Ricorsivo
 * Crea 2 processi concorrenti legati alal stessa funzione
 * Tale funzione crea due file e confronta il filesystem su pipe
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include  <sys/types.h>
#include  <sys/stat.h>
#include  <dirent.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <unistd.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <unistd.h>
#include  <limits.h>
#include  <errno.h>
#include  <stdarg.h>
#include <signal.h>

#define N 100
#define SPACE 2
#define BUFFSIZE 4096

int pipeFtoP[2];
int semaforo[2];

void visitDirRecur (char *, int, int, int);
void aborted ();

void sem_init (int *s) { pipe (s); }
void sem_signal (int* s) { write (s[1], "X", 1); }
void sem_wait (int* s) { char b; read (s[0], &b, 1); }

void
aborted (
  )
{
  exit (1);
}


int main (
  int argc,
  char *argv[]
  )
{
  int f, fd;

  if (argc != 3) {
    fprintf (stderr, "usage: pgrm <pathnameR> <pathnameW");
    exit (1);
  }

  setbuf (stdout, 0);
  pipe (pipeFtoP);
  sem_init (semaforo);

  f = fork();
  if (f==0) {
    /* Figlio */
    close (pipeFtoP[0]);
    signal (SIGUSR1, aborted);
    fd = open ("figlio.txt", O_WRONLY | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR);
    if (fd==(-1)) {
      fprintf (stdout, "File Open Error\n");
      exit (1);
    }
    visitDirRecur (argv[1], f, fd, 1);
    close (fd);
  } else {
    /* Padre */
    close (pipeFtoP[1]);
    fd = open ("padre.txt", O_WRONLY | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR);
    if (fd==(-1)) {
      fprintf (stdout, "File Open Error\n");
      exit (1);
    }
    visitDirRecur (argv[2], f, fd, 1);
    close (fd);
  }

  return (0);
}

void
visitDirRecur (
  char *fullnameR,
  int pid,
  int fid,
  int level
  )
{
  DIR *dp;
  struct stat statbuf;
  struct dirent *dirp;
  int n;
  char nameR[N], str[N], str2[N];

  if (lstat(fullnameR, &statbuf) < 0 ) {
    fprintf (stderr, "Error Running lstat.\n");
    exit (1);
  }

  if (S_ISDIR(statbuf.st_mode) == 0) {
    fprintf (stderr, "Error NOt A Directory.\n");
    exit (1);
  }

  /* Directory */
  if ( (dp = opendir(fullnameR)) == NULL) {
    fprintf (stderr, "Error Opening Dir.\n");
    exit (1);
  }

  while ( (dirp = readdir(dp)) != NULL) {
    if (pid==0) {
      /* Figlio */
      sprintf (str, "%3d%s", strlen (dirp->d_name), dirp->d_name);
      write (pipeFtoP[1], str, strlen(str));
      sprintf (str2, "Son[%s]\n", str);
      write (fid, str2, strlen(str2));
      sem_wait (semaforo);
    } else {
      /* Padre */
      sprintf (str, "Father[%3d%s]\n", strlen (dirp->d_name), dirp->d_name);
      write (fid, str, strlen(str));
      read (pipeFtoP[0], str, 3); str[3]='\0'; /*printf ("(1)[%s]\n", str);*/
      n = atoi (str);
      read (pipeFtoP[0], str, n); str[n]='\0'; /*printf ("(2)[%s]\n", str);*/
      sprintf (str2, "FatherFromSon[%3d%s]\n", n, str);
      write (fid, str2, strlen(str2));
      if (strcmp (dirp->d_name, str) == 0) {
        printf ("Equal [%s - %s]\n", dirp->d_name, str);
      } else {
        printf ("Different [%s - %s] -> Abort\n", dirp->d_name, str);
        kill (pid, SIGUSR1);
        exit (1);
      }
      sem_signal (semaforo);
    }

    sprintf (nameR, "%s/%s", fullnameR, dirp->d_name);

    if (lstat(nameR, &statbuf) < 0 ) {
      fprintf (stderr, "Error Running lstat.\n");
      exit (1);
    }

    if (S_ISDIR(statbuf.st_mode) == 0) {
      /* File */
      /* Nothing to do */
    } else {
      /* Directory */
      if (strcmp(dirp->d_name, ".") == 0  ||
        strcmp(dirp->d_name, "..") == 0)
        continue;

      visitDirRecur (nameR, pid, fid, level+1);
    }

  }

  if (closedir(dp) < 0) {
    fprintf (stderr, "Error.\n");
    exit (1);
  }

  return;
}
