/*Scrivere un client che si colleghi ad un server TCP all’indirizzo e porta specificati come primo e
secondo parametro sulla riga di comando e quindi termini chiudendo correttamente il canale e
segnalando se il collegamento è riuscito o fallito.*/

//CLIENT

#include "sockwrap.h"
#include "errlib.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

char * prog_name;

int main(int argc, char *argv[])
{
    int sock;
    short port;
    struct sockaddr_in servaddr;
    struct hostent * server;
    
    prog_name = argv[0];
    
    if (argc != 3)
	err_quit ("usage: %s <address> <port>\n", prog_name);
    port = atoi(argv[2]);
    
    sock = Socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    err_msg("(%s) socket created", prog_name);
    
    server = Gethostbyname(argv[1]);	
    
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET; //AF_INET, AF_INET6, AF_UNSPEC
    servaddr.sin_port = htons(port);
    memcpy((char *)server->h_addr, (char *)&servaddr.sin_addr.s_addr, server->h_length);
    
    Connect(sock, (struct sockaddr*) &servaddr, sizeof(servaddr));
     
    sleep(3);
    
    Close(sock);
    
    err_msg("(%s) Collegamento riuscito\n", prog_name);
    
    return 0;
}