/*Scrivere un client che si colleghi ad un server TCP all’indirizzo e porta specificati come primo e
secondo parametro sulla riga di comando e quindi termini chiudendo correttamente il canale e
segnalando se il collegamento è riuscito o fallito.*/

//SERVER

#include "sockwrap.h"
#include "errlib.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <string.h>

#define MAX_LEN 1024

char * prog_name;

int main(int argc, char *argv[])
{
    int listenfd, connfd, reuseaddr = 1;
    short port;
    struct sockaddr_in servaddr, cliaddr;
    socklen_t cliaddrlen = sizeof(cliaddr);
    char buffer[MAX_LEN];
    
    prog_name = argv[0];
    
    if (argc != 2)
	err_quit ("usage: %s <port>\n", prog_name);
    port = atoi(argv[1]);
    
    listenfd = Socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if(setsockopt(listenfd, SOL_SOCKET, SO_REUSEADDR, &reuseaddr, sizeof(int)) == -1)
	err_quit("(%s) socket options", prog_name);
    err_msg("(%s) socket created", prog_name);
    
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET; //AF_INET, AF_INET6, AF_UNSPEC
    servaddr.sin_port = htons(port);
    servaddr.sin_addr.s_addr = INADDR_ANY;
    
    Bind(listenfd, (SA*) &servaddr, sizeof(servaddr));
    
    Listen(listenfd, 1);
    err_msg("(%s) listening on %s:%u", prog_name, inet_ntoa(servaddr.sin_addr), ntohs(servaddr.sin_port));
    
    while (1)
    {
	err_msg ("(%s) waiting for connections ...", prog_name);
	connfd = Accept (listenfd, (SA*) &cliaddr, &cliaddrlen);
	err_msg("(%s) - new connection from client %s:%u", prog_name, inet_ntoa(cliaddr.sin_addr), ntohs(cliaddr.sin_port));
	
	Read(connfd, buffer, MAX_LEN);
	
	Close (connfd);
	err_msg ("(%s) - connection closed by client", prog_name);
    }
    return 0;
}