/* Sviluppare un client che si colleghi ad un server TCP all’indirizzo e porta specificati come primo e
secondo parametro sulla riga di comando e quindi invii due numeri interi senza segno
(rappresentabili in binario puro su 16 bit) letti da standard input e riceva la risposta
(somma, o errore) dal server. Come server puo' essere utilizzato quello compilato nell'esercizio 1.1
La somma è un numero intero senza segno a 16 bit, ma il server gestisce anche il caso di overflow,
che è segnalato con uno specifico errore (si veda l’esempio).
Il client invia al server i due numeri in notazione decimale espressi mediante caratteri numerici
ASCII. I numeri devono essere separati da un solo spazio e la trasmissione deve essere terminata
con CR-LF. Il server restituisce il risultato (un solo numero) espresso mediante caratteri ASCII,
privo di spazi e terminato con CR-LF oppure un messaggio di errore (caratteri ASCII) terminato
anch’esso da CR-LF.
Esempi (ogni elemento rappresenta un singolo byte trasmesso in codice ASCII):
(client -> server)
1 2 3 4 5
3
CR LF
(server -> client)
1 2 3 4 8 CR LF
o in caso di errore:
(server -> client) o v e r f l o w CR LF
(server -> client) i n c o r r e c t */

#include "sockwrap.h"
#include "errlib.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

#define MAXLEN 1024

char * prog_name;

int my_getline (char *, int);

int main(int argc, char *argv[])
{
    int sock;
    short port;
    struct sockaddr_in servaddr;
    struct hostent * server;
    char buffer[MAXLEN];
    
    prog_name = argv[0];
    
    if (argc != 3)
	err_quit ("usage: %s <address> <port>\n", prog_name);
    port = atoi(argv[2]);
    
    sock = Socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    err_msg("(%s) socket created", prog_name);
    
    server = Gethostbyname(argv[1]);	
    
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET; //AF_INET, AF_INET6, AF_UNSPEC
    servaddr.sin_port = htons(port);
    memcpy((char *)server->h_addr, (char *)&servaddr.sin_addr.s_addr, server->h_length);
    
    Connect(sock, (struct sockaddr*) &servaddr, sizeof(servaddr));
    err_msg("(%s) host connected", prog_name);
    
    int n = my_getline(buffer, MAXLEN);
    Write(sock, buffer, n);    
    Readline (sock, buffer, MAXLEN);
    printf("Somma: %s", buffer);
    
    Close(sock);
    
    err_msg("(%s) Collegamento riuscito", prog_name);
    
    return 0;
}

int my_getline (char * s, int lim)
{
    int i;
    char c;
    for (i = 0; i < lim - 1 && (c = getchar()) != '\n'; i++)
	s[i] = c;
    s[i++] = '\0';
    return i;
}