/* Scrivere un client che invii ad un server UDP (all’indirizzo e porta specificati come primo e
secondo parametro sulla riga di comando) un datagramma contenente il nome (massimo 31
caratteri) passato come terzo parametro sulla riga di comando, attenda quindi un qualunque
datagramma di risposta dal server. Il client termina mostrando il contenuto (testo ASCII) del
datagramma ricevuto oppure segnalando che non ha ricevuto risposta dal server entro un certo
tempo.
Sviluppare un server UDP (in ascolto sulla porta specificata come primo parametro sulla riga di
comando) che risponda ad ogni datagramma ricevuto inviando un datagramma di risposta
contenente lo stesso nome presente nel pacchetto ricevuto.
Provare ad effettuare degli scambi di datagrammi tra client e server con le seguenti configurazioni:
• client invia datagramma ad una porta su cui il server è in ascolto
• client invia datagramma ad una porta su cui il server non è in ascolto
• client invia datagramma ad un indirizzo non raggiungibile (es. 10.0.0.1)
Provare a collegare il proprio client col server sviluppato da un altro gruppo e viceversa.*/

//CLIENT

#include "sockwrap.h"
#include "errlib.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <time.h>

#define MAXLEN 1024

char * prog_name;
int recvtimeout(int, char *, int, int);

int main(int argc, char *argv[])
{
    int sock, n, sleeptime;
    short port;
    struct sockaddr_in servaddr;
    struct hostent * server;
    char buffer[MAXLEN];
    srand(time(0));
    
    sleeptime = rand()%5 + 1;
    prog_name = argv[0];
    
    if (argc != 4)
	err_quit ("usage: %s <address> <port> <message>\n", prog_name);
    port = atoi(argv[2]);
    
    sock = Socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    err_msg("(%s) socket created", prog_name);
    
    server = Gethostbyname(argv[1]);	
    
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET; //AF_INET, AF_INET6, AF_UNSPEC
    servaddr.sin_port = htons(port);
    memcpy((char *)server->h_addr, (char *)&servaddr.sin_addr.s_addr, server->h_length);
    
    Connect(sock, (struct sockaddr*) &servaddr, sizeof(servaddr));
    
    Send(sock, argv[3], strlen(argv[3])+1, 0);
    //Sendto(sock, argv[3], strlen(argv[3])+1, 0, (SA *) &servaddr, sizeof(servaddr));
    
    printf("Aspetto %d secondi\n", sleeptime);
    n = recvtimeout(sock, buffer, sizeof(buffer), sleeptime);
    
    if(n >= 0)
	printf("Messaggio dal server: %s\n", buffer);
    else if(n == -2)
	printf("Timeout scaduto!\n");
    else
	printf("Errore!\n");
    
    Close(sock);
    
    return 0;
}

int recvtimeout(int s, char * buf, int len, int timeout)
{
    fd_set fds;
    int n;
    struct timeval tv;
    
    FD_ZERO(&fds);
    FD_SET(s, &fds);
    
    tv.tv_sec = timeout;
    tv.tv_usec = 0;
    
    n = select(s+1, &fds, NULL, NULL, &tv);
    if (n == 0) return -2;
	if (n == -1) return -1;
	    return recv(s, buf, len, 0);
}
