/* Scrivere un client che invii ad un server UDP (all’indirizzo e porta specificati come primo e
secondo parametro sulla riga di comando) un datagramma contenente il nome (massimo 31
caratteri) passato come terzo parametro sulla riga di comando, attenda quindi un qualunque
datagramma di risposta dal server. Il client termina mostrando il contenuto (testo ASCII) del
datagramma ricevuto oppure segnalando che non ha ricevuto risposta dal server entro un certo
tempo.
Sviluppare un server UDP (in ascolto sulla porta specificata come primo parametro sulla riga di
comando) che risponda ad ogni datagramma ricevuto inviando un datagramma di risposta
contenente lo stesso nome presente nel pacchetto ricevuto.
Provare ad effettuare degli scambi di datagrammi tra client e server con le seguenti configurazioni:
• client invia datagramma ad una porta su cui il server è in ascolto
• client invia datagramma ad una porta su cui il server non è in ascolto
• client invia datagramma ad un indirizzo non raggiungibile (es. 10.0.0.1)
Provare a collegare il proprio client col server sviluppato da un altro gruppo e viceversa.*/

//SERVER

#include "sockwrap.h"
#include "errlib.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>

#define MAX_LEN 1024

char * prog_name;

int main(int argc, char *argv[])
{
    int sock, reuseaddr = 1, sleeptime;
    short port;
    struct sockaddr_in servaddr, cliaddr;
    socklen_t cliaddrlen = sizeof(cliaddr);
    char buffer[MAX_LEN];
    srand(time(0));
    
    sleeptime = rand()%5 + 1;
    prog_name = argv[0];
    
    if (argc != 2)
	err_quit ("usage: %s <port>\n", prog_name);
    port = atoi(argv[1]);
    
    sock = Socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &reuseaddr, sizeof(int)) == -1)
	err_quit("(%s) socket options", prog_name);
    err_msg("(%s) socket created", prog_name);
    
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET; //AF_INET, AF_INET6, AF_UNSPEC
    servaddr.sin_port = htons(port);
    servaddr.sin_addr.s_addr = INADDR_ANY;
    
    Bind(sock, (SA*) &servaddr, sizeof(servaddr));
    
    Recvfrom (sock, buffer, sizeof(buffer), 0, (SA *) &cliaddr, &cliaddrlen);
    printf("Ricevuto: %s\n", buffer);
    
    printf("Invio tra %d secondi\n", sleeptime);
    sleep(sleeptime);
    printf("Invio %s\n", buffer);
    Sendto(sock, buffer, sizeof(buffer), 0, (SA *) &cliaddr, cliaddrlen);
    
    Close(sock);
    
    return 0;
}