/*Modificare il client UDP dell’esercizio 1.4 in modo che – nel caso non riceva risposta dal server
entro 3 secondi – ritrasmetta la richiesta (fino ad un massimo di 5 volte) e quindi termini indicando
se ha ricevuto risposta o meno.
Effettuare le stesse prove dell’esercizio 1.4.
*/

//CLIENT

#include "sockwrap.h"
#include "errlib.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <time.h>

#define MAXLEN 1024

char * prog_name;
int recvtimeout(int, char *, int, int);

int main(int argc, char *argv[])
{
    int i, sock, n, sleeptime;
    short port;
    struct sockaddr_in servaddr;
    struct hostent * server;
    char buffer[MAXLEN];
    srand(time(0));
    
    sleeptime = rand()%5 + 1;
    prog_name = argv[0];
    
    if (argc != 4)
	err_quit ("usage: %s <address> <port> <message>\n", prog_name);
    port = atoi(argv[2]);
    
    sock = Socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    err_msg("(%s) socket created", prog_name);
    
    server = Gethostbyname(argv[1]);	
    
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET; //AF_INET, AF_INET6, AF_UNSPEC
    servaddr.sin_port = htons(port);
    memcpy((char *)server->h_addr, (char *)&servaddr.sin_addr.s_addr, server->h_length);
    
    Connect(sock, (struct sockaddr*) &servaddr, sizeof(servaddr));
    
    Send(sock, argv[3], strlen(argv[3])+1, 0);
    //Sendto(sock, argv[3], strlen(argv[3])+1, 0, (SA *) &servaddr, sizeof(servaddr));
    
    for(i = 1; i <= 5; i++)
    {
	printf("Aspetto %d secondi (tentativo %d)\n", sleeptime, i);
	n = recvtimeout(sock, buffer, sizeof(buffer), sleeptime);
	
	if(n >= 0){
	    printf("Messaggio dal server: %s\n", buffer);
	    break;
	}
	else if(n == -2){
	    printf("Timeout %d scaduto! ", i);
	    if(i == 5)
		printf("Messaggio non ricevuto!\n");
	    else
		printf("\n");
	}
	else
	    printf("Errore!\n");
    }
    Close(sock);
    
    return 0;
}

int recvtimeout(int s, char * buf, int len, int timeout)
{
    fd_set fds;
    int n;
    struct timeval tv;
    
    FD_ZERO(&fds);
    FD_SET(s, &fds);
    
    tv.tv_sec = timeout;
    tv.tv_usec = 0;
    
    n = select(s+1, &fds, NULL, NULL, &tv);
    if (n == 0) return -2;
	if (n == -1) return -1;
	    return recv(s, buf, len, 0);
}
