/* Modificare il client UDP dell’esercizio 1.4 in modo che – nel caso non riceva risposta dal server
entro 3 secondi – ritrasmetta la richiesta (fino ad un massimo di 5 volte) e quindi termini indicando
se ha ricevuto risposta o meno.
Effettuare le stesse prove dell’esercizio 1.4.
*/

//SERVER

#include "sockwrap.h"
#include "errlib.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>

#define MAX_LEN 1024

char * prog_name;

int main(int argc, char *argv[])
{
    int sock, reuseaddr = 1, sleeptime;
    short port;
    struct sockaddr_in servaddr, cliaddr;
    socklen_t cliaddrlen = sizeof(cliaddr);
    char buffer[MAX_LEN];
    srand(time(0));
    
    sleeptime = rand()%20 + 1;
    prog_name = argv[0];
    
    if (argc != 2)
	err_quit ("usage: %s <port>\n", prog_name);
    port = atoi(argv[1]);
    
    sock = Socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &reuseaddr, sizeof(int)) == -1)
	err_quit("(%s) socket options", prog_name);
    err_msg("(%s) socket created", prog_name);
    
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET; //AF_INET, AF_INET6, AF_UNSPEC
    servaddr.sin_port = htons(port);
    servaddr.sin_addr.s_addr = INADDR_ANY;
    
    Bind(sock, (SA*) &servaddr, sizeof(servaddr));
    
    Recvfrom (sock, buffer, sizeof(buffer), 0, (SA *) &cliaddr, &cliaddrlen);
    printf("Ricevuto: %s\n", buffer);
    
    printf("Invio tra %d secondi\n", sleeptime);
    sleep(sleeptime);
    printf("Invio %s\n", buffer);
    Sendto(sock, buffer, sizeof(buffer), 0, (SA *) &cliaddr, cliaddrlen);
    
    Close(sock);
    
    return 0;
}