/*Modificare il server UDP dell’esercizio 1.4 in modo che invii risposta ad un client solo se questi
non ha effettuato più di tre richieste (dall’attivazione del server). Il server deve essere in grado di
riconoscere gli ultimi 10 client che hanno fatto richiesta.
Provare quindi ad attivare verso questo server quattro volte il client dell’esercizio 1.4.
Provare infine ad attivare verso questo server due client posti su due nodi di rete diversi, in
alternanza tra loro, quattro volte per ciascun client.*/

//CLIENT

#include "sockwrap.h"
#include "errlib.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

#define MAXLEN 1024

char * prog_name;
int recvtimeout(int, char *, int, int);

int main(int argc, char *argv[])
{
    int i, tentativi, sock, n;
    short port;
    struct sockaddr_in servaddr;
    struct hostent * server;
    char buffer[MAXLEN];
    srand(time(0));
    
    prog_name = argv[0];
    
    if (argc != 5)
	err_quit ("usage: %s <address> <port> <message> <tentativi>\n", prog_name);
    port = atoi(argv[2]);
    tentativi = atoi(argv[4]);
    
    sock = Socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    err_msg("(%s) socket created", prog_name);
    
    server = Gethostbyname(argv[1]);	
    
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET; //AF_INET, AF_INET6, AF_UNSPEC
    servaddr.sin_port = htons(port);
    memcpy((char *)server->h_addr, (char *)&servaddr.sin_addr.s_addr, server->h_length);
    
    Connect(sock, (struct sockaddr*) &servaddr, sizeof(servaddr));
    
    Send(sock, argv[3], strlen(argv[3])+1, 0);
    //Sendto(sock, argv[3], strlen(argv[3])+1, 0, (SA *) &servaddr, sizeof(servaddr));
    
    for(i = 0; i < tentativi; i++)
    {
	n = recvtimeout(sock, buffer, sizeof(buffer), -1);
	if(n >= 0){
	    printf("Messaggio dal server: %s\n", buffer);
	    break;
	}   
	else
	    printf("Errore!\n");
    }
    
    Close(sock);
    
    return 0;
}

int recvtimeout(int s, char * buf, int len, int timeout)
{
    fd_set fds;
    int n;
    struct timeval tv;
    
    FD_ZERO(&fds);
    FD_SET(s, &fds);
    
    tv.tv_sec = timeout;
    tv.tv_usec = 0;
    
    if(timeout >= 0)
	n = select(s+1, &fds, NULL, NULL, &tv);
    else
	n = select(s+1, &fds, NULL, NULL, NULL);
    if (n == 0) return -2;
	if (n == -1) return -1;
	    return recv(s, buf, len, 0);
}
