/* Modificare il server UDP dell’esercizio 1.4 in modo che invii risposta ad un client solo se questi
non ha effettuato più di tre richieste (dall’attivazione del server). Il server deve essere in grado di
riconoscere gli ultimi 10 client che hanno fatto richiesta.
Provare quindi ad attivare verso questo server quattro volte il client dell’esercizio 1.4.
Provare infine ad attivare verso questo server due client posti su due nodi di rete diversi, in
alternanza tra loro, quattro volte per ciascun client.*/

//SERVER

#include "sockwrap.h"
#include "errlib.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

#define SAI struct sockaddr_in
#define MAX_LEN 1024
#define MAX_CLIENT 10

char * prog_name;

typedef struct
{
    int contatore;
    struct in_addr sin_addr;
} addr_mem;
	
int ricerca_presenza(SAI * cliaddr);
int pos = 0;
addr_mem mem[MAX_CLIENT];

int main (int argc, char *argv[])
{  
	int socket, fromlen;	
	short port;
	char buffer[MAX_LEN];
	prog_name = argv[0];
	struct sockaddr_in servaddr, cliaddr;
	
	if (argc != 2)
	    err_quit ("Numero di parametri errato per %s", prog_name);

	port = atoi(argv[1]);  

	socket = Socket (PF_INET, SOCK_DGRAM, 0);

	memset(&servaddr, 0, sizeof(servaddr));
	servaddr.sin_family = AF_INET;
	servaddr.sin_port = htons(port);
	servaddr.sin_addr.s_addr = htonl (INADDR_ANY);

	Bind(socket, (SA*) &servaddr, sizeof(servaddr));

	err_msg("(%s) socket created",prog_name);
	err_msg("(%s) listening on %s:%u", prog_name, inet_ntoa(servaddr.sin_addr), ntohs(servaddr.sin_port));

	while (1)
	{
		fromlen = sizeof(cliaddr);
		Recvfrom (socket, buffer, MAX_LEN, 0, (struct sockaddr *) &cliaddr, &fromlen);

		printf ("Ricevuto un datagramma con contenuto: %s\n", buffer);
			
		if (ricerca_presenza(&cliaddr) < 4)  
		    Sendto (socket, (void*)buffer, MAX_LEN, 0, (struct sockaddr *) &cliaddr, sizeof(cliaddr));
		else
		    printf ("Troppi datagrammi inviati\n");
	}

}

int ricerca_presenza(SAI *cliaddr)
{
    int contr, found = 0, i;
    for (i = 0; i < MAX_CLIENT; i++)
    {
	if (mem[i].sin_addr.s_addr == cliaddr->sin_addr.s_addr)
	{
	    mem[i].contatore++;
	    return mem[i].contatore;
	}	
    }
    
    if(pos == MAX_CLIENT)
	pos = 0;
    
    mem[pos].sin_addr.s_addr = cliaddr->sin_addr.s_addr;
    mem[pos].contatore = 1;
    pos++;
    return 1;
}
