CREATE OR REPLACE TRIGGER Consistenza_update
AFTER UPDATE ON IMP
FOR EACH ROW
DECLARE
	N NUMBER;
BEGIN
	--Contiamo quanti impiegati svolgono il vecchio lavoro
	--dell'impiegato inserito (lui compreso)
	SELECT COUNT(*) INTO N
	FROM SOMMARIO
	WHERE JOB = :OLD.JOB;
	
	--Aggiorniamo i valori per il vecchio lavoro
	IF(N = 1) THEN --c'era solo lui
		DELETE FROM SOMMARIO
		WHERE JOB = :OLD.JOB;
	ELSE
		UPDATE SOMMARIO
		SET NUM = NUM - 1
		WHERE :OLD.JOB;
	END IF;
	
	--Vediamo quanti fanno lo stesso lavoro del nuovo impiegato (il suo nuovo lavoro)
	SELECT COUNT(*) INTO N
	FROM SOMMARIO
	WHERE JOB = :NEW.JOB;
	
	IF(N = 0) THEN
		INSERT INTO SOMMARIO(JOB, NUM)
		VALUES(:NEW.JOB, 1);
	ELSE
		UPDATE SOMMARIO
		SET NUM = NUM + 1;
		WHERE JOB = :NEW.JOB;
	END IF;
END;