CREATE OR REPLACE TRIGGER Notify_Status
AFTER INSERT ON TICKETS
FOR EACH ROW
WHEN (NEW.CARDNO IS NOT NULL)
DECLARE
	FID NUMBER;
	CN NUMBER;
	M_PRIMA NUMBER;
	M NUMBER;
	M_DOPO NUMBER;
	OLD_STATUS VARCHAR(10);
	NEW_STATUS VARCHAR(10);
	CHANGE BOOLEAN;
	NN NUMBER;
BEGIN
	--Vediamo qual e' il volo e la carta associato al ticket appena emesso
	SELECT FLIGHTID, CARDNO INTO FID, CN
	FROM TICKETS
	WHERE TICKETID = :NEW.TICKETID;
	
	--Vediamo quante miglia percorre questo volo
	SELECT MILES INTO M
	FROM FLIGHTS
	WHERE FLIGHTID = FID;
	
	--Prima di aggiornare le miglia, vediamo le miglia attuali associate a questa carta
	SELECT SUM(MILES) INTO M_PRIMA
	FROM CREDITS
	WHERE CARDNO = CN
	GROUP BY CARDNO;
	
	--Aggiorniamo la tabella CREDITS
	UPDATE CREDITS
	SET MILES = MILES + M
	WHERE TICKETID = :NEW.TICKETID;
	
	--Verifichiamo che il cliente non abbia cambiato status
	M_DOPO := M_PRIMA + M;
	CHANGE := FALSE;
	IF(M_PRIMA < 30000 AND M_DOPO >= 30000) THEN
		OLD_STATUS := 'SILVER';
		NEW_STATUS := 'GOLD';
		CHANGE := TRUE;
	ELSE IF(M_PRIMA <= 50000 AND M_DOPO > 50000) THEN
		OLD_STATUS := 'GOLD';
		NEW_STATUS := 'PREMIUM';
		CHANGE := TRUE;
	END IF;
	
	IF(CHANGE = TRUE) THEN
		--Contiamo il numero di notifiche per questo cliente
		SELECT COUNT(*) INTO NN
		FROM NOTIFY
		WHERE CARDNO = CN;
		
		INSERT INTO NOTIFY(CARDNO, NOTIFYNO, NOTIFYDATE, OLDSTATUS, NEWSTATUS, TOTALMILES)
		VALUES(CN, NN + 1, SYSDATE, OLD_STATUS, NEW_STATUS, M_DOPO);
	END IF;
END;