use Stab1;

drop table rental;
drop table client;
drop table Item;
drop table ItemType;

create table ItemType
(TypeKey  INT NOT NULL,
 Type VARCHAR(20) NOT NULL,
 Category VARCHAR(20) NOT NULL,
 Description VARCHAR(20),
 PRIMARY KEY(TypeKey)
);


create table Item
(ItemKey  INT NOT NULL,
 TypeKey INT NOT NULL,
 Description VARCHAR(20),
 PRIMARY KEY(ItemKey),
 FOREIGN KEY(TypeKey) REFERENCES ItemType(TypeKey) on delete cascade on update cascade
);


create table client
(ClientKey INT NOT NULL,
 FirstName VARCHAR(15) NOT NULL,
 LastName VARCHAR(15) NOT NULL,
 PhoneNumber VARCHAR(15)
 PRIMARY KEY(ClientKey)
);



create table rental
(ItemKey INT NOT NULL,
 Date DATETIME NOT NULL,
 StartHour INT NOT NULL,
 EndHour INT NOT NULL,
 ClientKey INT NOT NULL,
 PaymentType VARCHAR(15) NOT NULL,
 Cost FLOAT NOT NULL,
 PRIMARY KEY(ItemKey,Date,StartHour),
 FOREIGN KEY(ItemKey) REFERENCES Item(ItemKey) on delete cascade on update cascade,
 FOREIGN KEY(ClientKey) REFERENCES Client(ClientKey) on delete cascade on update cascade
);



